import json

from tornado.web import RequestHandler

from agent.domain import DOMAINOBJ, DOMAINMSG
from agent.common.pylog import logger


class BackupHandler(RequestHandler):
    def post(self):
        """ Backup parameters value to backup file
        
        """
        request_data = json.loads(self.request.body)
        logger.debug("[Request] Get backup request:{}".format(request_data))

        domain_result = {}
        for domain_name, param_list in request_data.items():
            if not DOMAINOBJ.__contains__(domain_name) and DOMAINMSG.__contains__(domain_name):
                domain_result[domain_name] = "inactive domain '{}':{}".format(domain_name, DOMAINMSG[domain_name])

            elif not DOMAINOBJ.__contains__(domain_name):
                domain_result[domain_name] = "undefined domain '{}'".format(domain_name)

            else:
                try:
                    domain_result[domain_name] = DOMAINOBJ[domain_name].Backup(param_list, all = False)

                except Exception as e:
                    domain_result[domain_name] = "Backup failed: {}".format(e)

        logger.debug("[Request] backup request result:{}".format(domain_result))
        self.write(json.dumps(domain_result))
        self.finish()