import json

from tornado.web import RequestHandler

from agent.domain import DOMAINOBJ, DOMAINMSG
from agent.common.pylog import logger
from agent.common.system import httpResponse


class ConfigureHandler(RequestHandler):
    def _configureImpl(self, param_domain_dict:dict, readonly:bool):
        domain_result = {}
        for domain_name, param_list in param_domain_dict.items():
            if not DOMAINOBJ.__contains__(domain_name) and DOMAINMSG.__contains__(domain_name):
                domain_result[domain_name] = "inactive domain '{}':{}".format(domain_name, DOMAINMSG[domain_name])
                continue

            elif not DOMAINOBJ.__contains__(domain_name):
                domain_result[domain_name] = "undefined domain '{}'".format(domain_name)
                continue
            
            else:
                if readonly:
                    domain_result[domain_name] = dict(DOMAINOBJ[domain_name].GetParam(param_list))
                else:
                    domain_result[domain_name] = dict(DOMAINOBJ[domain_name].SetParam(param_list))
                    
        return domain_result

    def post(self):
        request_data = json.loads(self.request.body)
        self.write(json.dumps({"suc" : True, "msg" : ""}))
        self.finish()
        
        logger.debug("[Request] Get configure request:{}".format(request_data))
        res = self._configureImpl(request_data['data'], request_data['readonly'])

        response_data = {
            "data"      : res,
            "target_id" : request_data['target_id'], 
        }
        logger.debug("[Request] configure request result: {}".format(response_data))
        httpResponse(response_data, request_data['resp_ip'], request_data['resp_port'])